<?
/* Component path functions for published projects */

Function InitWebDev() {
	global $WEBDEV_CONF,$UID;

	if ($WEBDEV_CONF["SessionIDs"] && !isset($UID)) {
		$UID= uniqid("");
		//$UID= md5(uniqid(""));
		if ($WEBDEV_CONF["UseCookies"])
			SetCookie("UID",$UID);
	}
}

Function PagePath ($comp,$param="") {
	global $WEBDEV_CONF,$UID;

	if (!$WEBDEV_CONF["SessionIDs"] || $WEBDEV_CONF["UseCookies"]) {
		$str = $WEBDEV_CONF["baseuri"]. "$comp.".
			$WEBDEV_CONF["phpext"];
		if ($param)
			$str .= "?$param";
		return $str;
	}

	if (!$UID) {
		$UID= uniqid("");
		//$UID= md5(uniqid(""));
	}

	$str = $WEBDEV_CONF["baseuri"]. "$comp.".
		$WEBDEV_CONF["phpext"]. "?UID=$UID";
	if ($param)
		$str .= "&amp;$param";
	return $str;
}

Function IncludePath ($dir,$comp) {
	global $WEBDEV_CONF;
	return $WEBDEV_CONF["Includes"][$dir]."$comp.".$WEBDEV_CONF["phpext"];
}

Function WebDevPath ($comp) {
	return IncludePath("WebDev",$comp);
}

Function ProjectPath ($comp) {
	return IncludePath("Project",$comp);
}

Function ResourcePath ($comp,$file) {
	global $WEBDEV_CONF;
	return $WEBDEV_CONF["Resources"][$comp] . "/$file";
}

// ODBC compatibility
class OdbcObject {};

function odbc_fetch_object ($res) {
	if (!odbc_fetch_row($res)) {
		return "";
	}
	$obj = new OdbcObject;
	$cols = odbc_num_fields($res);
	for ($i = 1; $i <= $cols; $i++) {
		$tmp = odbc_field_name($res, $i);
		$obj->$tmp = odbc_result($res, $tmp);
	}
	return $obj;
}

function odbc_fetch_array ($res) {
	if (!odbc_fetch_row($res)) {
		return "";
	}
	odbc_fetch_into($res, $ary);
	return $ary;
}

// PostgreSQL compatibility
function pg_free_result ($res) {
	return pg_freeresult($res);
}

function pg_num_rows ($res) {
	return pg_numrows($res);
}

class WebDevDb {
	var $db,$conn,$res,$row;

	function WebDevDb ($dbname="Default") {
		$this->init($dbname);
	}
	function init ($dbname) {
		global $WEBDEV_CONF;

		if ($this->db && $this->db==$dbname)
			return;

		$this->db = $WEBDEV_CONF["Databases"][$dbname];
		if ($this->db["dbpersist"] == "persistent") {
			$func = $this->db["dbtype"] . "_pconnect";
		} else {
			$func = $this->db["dbtype"] . "_connect";
		}
		if ($this->db["dbtype"] == "odbc") {
			$this->conn = $func($this->db["dbname"],
				$this->db["dbuser"],
				$this->db["dbpassword"]);
		} elseif ($this->db["dbtype"] == "pg") {
			$this->conn = $func($this->db["dbhost"],
				"","","",
				$this->db["dbname"]);
			$this->row = 0;
		} else {
			$this->conn = $func($this->db["dbhost"],
				$this->db["dbuser"],
				$this->db["dbpassword"]);
			$func = $this->db["dbtype"] . "_select_db";
			$func($this->db["dbname"],$this->conn);
		}
	}

	function deinit () {
		if ($this->res) {
			$func = $this->db["dbtype"] . "_free_result";
			@$func($this->res);
		}
		if ($this->db["dbpersist"] == "close") {
			$func = $this->db["dbtype"] . "_close";
			$func($this->conn);
		}
	}

	function free_result () {
		if ($this->res) {
			$func = $this->db["dbtype"] . "_free_result";
			@$func($this->res);
			Unset($this->res);
			$this->row = 0;
		}
	}

	function doquery () {
		if ($this->db["dbtype"] == "odbc" ||
			$this->db["dbtype"] == "pg") {
			$func = $this->db[dbtype] . "_exec";
			$this->res = $func($this->conn, $this->sql);
		} else {
			$func = $this->db["dbtype"] . "_query";
			$this->res = $func($this->sql, $this->conn);
		}
	}

	function fetch_object () {
		$func = $this->db["dbtype"] . "_fetch_object";
		if ($this->db["dbtype"] == "pg") {
			return @$func($this->res, $this->row++);
		}
		return @$func($this->res);
	}

	function fetch_array () {
		$func = $this->db["dbtype"] . "_fetch_array";
		if ($this->db["dbtype"] == "pg") {
			return @$func($this->res, $this->row++);
		}
		return @$func($this->res);
	}

	function num_rows () {
		$func = $this->db["dbtype"] . "_num_rows";
		if (!$this->res) {
			return 0;
		}
		return $func($this->res);
	}
};

class WebDevMenu {
	var $type,$width,$height,$selected,$orientation;
	var $itemcount,$splitchar,$imageres;

	function init($type,$width=0,$height=0,
			$selected="",$orientation="vertical",$imageres="") {
		$this->type = $type;
		$this->width = $width;
		$this->height = $height;
		$this->selected = $selected;
		$this->orientation = $orientation;
		$this->splitchar = "|";
		$this->itemcount = 0;
		$this->imageres = $imageres;
	}

	function AddItem($name,$url) {
		if ($this->orientation == "horizontal" &&
			$this->type == "text" &&
			$this->itemcount) {
			print " $this->splitchar\n";
		}
		$this->itemcount++;
		print "<A HREF=\"";
		if (ereg("^(http)|(https)|(ftp)://",$url)) {
			print $url;
		} else {
			print PagePath($url);
		}
		print "\">$name</A>";
		if ($this->orientation == "vertical") {
			print "<BR>\n";
		}
	}
};

class WebDevImageMenu extends WebDevMenu {
	function AddItem($name,$url,$unsel,$sel,$hi="") {
		global $WEBDEV_CONF;

		$this->itemcount++;
		$id = uniqid("");
		if ($this->selected == $name) {
			$img = $sel;
		} else {
			$img = $unsel;
		}
		print "<A \nHREF=\"";
		if (ereg("^(http)|(https)|(ftp)://",$url)) {
			print $url;
		} else {
			print PagePath($url);
		}
		print "\"";
		if ($hi) {
			print "\nOnMouseOver=\"setImage('$id','".
				ResourcePath($this->imageres,$hi). "')\"";
			print "\nOnMouseOut=\"setImage('$id','".
				ResourcePath($this->imageres,$img). "')\"\n";
		}
		print ">";
		print "<IMG SRC=\"". ResourcePath($this->imageres,$img).
			"\" WIDTH=".$this->width ." HEIGHT=".$this->height;
		print " BORDER=0 HSPACE=0 VSPACE=0 ALT=\"$name\" ".
			"NAME=\"$id\"></A>";
		if ($this->orientation == "vertical") {
			print "<BR>\n";
		}
	}
};

InitWebDev();
?>
